#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <vte/vte.h>

#include <shout/shout.h>
#include <sys/stat.h>
#include <errno.h>
#include <sys/ioctl.h>

#include <asm/types.h>          /* for videodev2.h */
#include <linux/videodev.h>
#include <linux/videodev2.h>


#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

int firsttime = 0;
int active = 0;
int preview2 = 0;
int fp;

int values[100];
GTimer *graph_time_tracker;


/* We create the dialog boxes once and keep pointers to them in static
   variables so we can reuse them. */
static GtkWidget *open_filesel = NULL;
static GtkWidget *open_infilesel = NULL;
static GtkWidget *save_filesel = NULL;
static GtkWidget *save_outfile1sel = NULL;
static GtkWidget *save_outfile2sel = NULL;
static GtkWidget *about = NULL;
static GtkWidget *assistant = NULL;

/* This is the filename of the file currently being edited, in on-disk
   encoding (which may be UTF-8 or the locale's encoding). */
static gchar *current_filename = NULL;

/* This flag is set to TRUE if the file has been changed. We don't actually
   use it here, but the program could be extended to prompt to save changes. */
static gboolean file_changed = FALSE;

/* A key used to store pointers to the main window. */
static const gchar *MainWindowKey = "MainWindowKey";

/* The size of chunks to read in when opening files. */
#define BUFFER_SIZE 8192


/* Static functions. */
static void new_file (GtkWidget *main_window);
static void open_file (GtkWidget *main_window);
static void open_infile (GtkWidget *main_window);
static void save_as (GtkWidget *main_window);

void real_open_file (GtkWidget *main_window,
			    const gchar *filename);
static void real_open_infile (GtkWidget *main_window,
			    const gchar *filename);
static void real_save_file (GtkWidget *main_window,
			    const gchar *filename);





int get_wlan_transmited ()
{
  char buffer[80];
  size_t bytes_read;
  char* match;
  int transmited;

  //obrim el fifo amb la informacio de bandwidth del ff
  if (!fp) fp = open("/tmp/tsspiperr1", O_NONBLOCK | O_RDONLY, 0);  

  read (fp, buffer, sizeof (buffer));

  /* Locate the line that includes the video info.  */
  match = strstr (buffer, " video:");
  if (match == NULL)
    return 0;
  /* Parse the line to extrace the bandwidth.  */
  sscanf (match, " video:%dkbps", &transmited);
  return transmited;
}
	
gboolean
update_graph (GtkWidget *widget)
{
	if (active==1) {
	  /* Get the elapsed time since the timer was started */
	    	gulong dumb_API_needs_this_variable;
	      	gdouble time_elapsed = g_timer_elapsed (graph_time_tracker, &dumb_API_needs_this_variable);

	int i,flag;
  	int transmited,transmitedpersec;
	transmited = get_wlan_transmited ();
	transmitedpersec = transmited;
	for (i=0; i<100; i++) {
		if (values[i] == -1) {values[i] = transmitedpersec; flag=1; }
		else flag=0;
	}
	if (flag == 0) {	
	  for (i=0; i<100; i++) {
		values[i] = values[i+1];
		values[99] = transmitedpersec;
	  }
	}

	  
	gdk_draw_rectangle (widget->window, widget->style->black_gc, TRUE, 0, 0, widget->allocation.width, widget->allocation.height);

	for (i=0; i<100; i++) {
	  gdk_draw_rectangle (widget->window, widget->style->white_gc, TRUE, (int)(3.6*i), 240-(int)values[i], widget->allocation.width / 100, values[i]);
	}

	    /* Return true so the function will be called again; returning false removes
	     *    * this timeout function.
	     *       */
	    return TRUE;
	}
}



gboolean
expose_event_callback (GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
	int i;
	for (i=0; i<100; i++) {
	  gdk_draw_rectangle (widget->window, widget->style->black_gc, TRUE, (int)(3.6*i), 240-(int)values[i], widget->allocation.width / 100, values[i]);
	}
	    return TRUE;
}


void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *entry = NULL;
  	GtkWidget *drawingarea1 = NULL;
	GtkWidget *combo;
	GtkWidget *toggle;
	gint active_index, v4l_index, dsp_index;
	FILE* script_file;
	gchar *gtest;
	gchar *server1, *port1, *pass1, *mountpoint1, *server2, *port2, *pass2, *mountpoint2, *localfile1, *localfile2, *inputfile;
	int mount1 = 0;
	int mount2 = 0;
	int local1 = 0;
	int local2 = 0;
	int infile = 0;
	const char*framesizes[20] = { "-x 160 -y 128", "-x 180 -y 144", "-x 256 -y 177", "-x 320 -y 240", "-x 360 -y 288", "-x 480 -y 360", "-x 512 -y 384", "-x 540 -y 432", "-x 640 -y 480", "-x 720 -y 576", "-x 160 -y 90", "-x 180 -y 101", "-x 256 -y 144", "-x 320 -y 180", "-x 360 -y 203", "-x 480 -y 270", "-x 512 -y 288", "-x 540 -y 304", "-x 640 -y 360", "-x 720 -y 405" };
	const char*framesizes_ff[20] = { "160x128", "180x144", "256x177", "320x240", "360x288", "480x360", "512x384", "540x432", "640x480", "720x576", "160x90", "180x101", "256x144", "320x180", "360x203", "480x270", "512x288", "540x304", "640x360", "720x405" };
	const char*framerates[5] = {"-F 25", "-F 25:2", "-F 25:3", "-F 25:4", "-F 25:5"};	
	const int samplerates[4] = {11025, 22050, 44100, 48000};
	const char*v4ldevs[4] = {"/dev/video0","/dev/video1","/dev/video2"};
	const char*dspdevs[4] = {"/dev/dsp","/dev/dsp0","/dev/dsp1","/dev/dsp2"};
	const int inputframerates[10] = {5, 7, 10, 12, 15, 20, 24, 25, 29, 30};
		
	int i;
	for (i=0; i<100; i++) {
	  values[i]=-1;
	}


	// TODO s'ha de checkejar si existeix el dvgrab, si existeix el ffmpeg2theora, si existeix el oggfv, si existeix el theora_player ... si algun d'aquests falla informar en una finestra d'error
	
	
	//check de camps imprescindibles (server1 AND port1 AND pass1 AND mountpoint1) OR (server2 AND port2 AND pass2 AND mountpoint2) OR (filename) ... si no, informar en una finestra d'error
	//
	
	entry = lookup_widget(GTK_WIDGET(button), "entry39");
	server1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry40");
	port1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry41");
	mountpoint1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry42");
	pass1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	
	entry = lookup_widget(GTK_WIDGET(button), "entry54");
	server2 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry55");
	port2 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry56");
	mountpoint2 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry57");
	pass2 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);

	entry = lookup_widget(GTK_WIDGET(button), "entry80");
	localfile1= gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry81");
	localfile2= gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry82");
	inputfile= gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	
	if ((strlen(server1) > 5) && (strlen(port1)  > 1) && (strlen(pass1) > 1) && (strlen(mountpoint1) > 4)) mount1 = 1;
	else mount1 = 0;	
	if ((strlen(server2) > 5) && (strlen(port2)  > 1) && (strlen(pass2) > 1) && (strlen(mountpoint2) > 4)) mount2 = 1;	
	else mount2 = 0;

	if (strlen(localfile1) > 1) local1 = 1;	
	else local1 = 0;	
	if (strlen(localfile2) > 1) local2 = 1;	
	else local2 = 0;	

	if (strlen(inputfile) > 1) infile = 1;	
	else infile = 0;	

  	GtkWidget *statusbar_main = lookup_widget (GTK_WIDGET (button), "statusbar_main");;
  	guint ctxt = gtk_statusbar_get_context_id (statusbar_main, "salutacio");


     if (mount1 || mount2) {
	/*First of all check if the server settings and connection are ok!*/
	int shout_error=0; 

	shout_t *shout;
	shout_init();

  	gtk_statusbar_push(statusbar_main, ctxt, _("checking server connection ... "));

     if (mount1) {

	if (!(shout = shout_new())) {
                printf("Could not allocate shout_t\n");
                shout_error=1;
        }

	if (shout_set_host(shout, gtk_entry_get_text (lookup_widget (GTK_WIDGET (button), "entry39"))) != SHOUTERR_SUCCESS) {
                printf("Error setting hostname: %s\n", shout_get_error(shout));
                shout_error=1;
        }

	if (shout_set_protocol(shout, SHOUT_PROTOCOL_HTTP) != SHOUTERR_SUCCESS) {
		printf("Error setting protocol: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	if (shout_set_port(shout, atoi ( gtk_entry_get_text (lookup_widget (GTK_WIDGET (button), "entry40")) ) ) != SHOUTERR_SUCCESS) {
		printf("Error setting port: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	if (shout_set_password(shout, gtk_entry_get_text (lookup_widget (GTK_WIDGET (button), "entry42"))) != SHOUTERR_SUCCESS) {
		printf("Error setting password: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	if (shout_set_mount(shout, gtk_entry_get_text (lookup_widget (GTK_WIDGET (button), "entry41"))) != SHOUTERR_SUCCESS) {
		printf("Error setting mount: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	if (shout_set_user(shout, "source") != SHOUTERR_SUCCESS) {
		printf("Error setting user: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	if (shout_set_format(shout, SHOUT_FORMAT_OGG) != SHOUTERR_SUCCESS) {
		printf("Error setting user: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	if (shout_error==1) {
		printf("Error setting connection params: %s\n", shout_get_error(shout));
	  	GtkWidget *main_window = lookup_widget (GTK_WIDGET (button), "window1");
		GtkWidget *dialog = gtk_message_dialog_new_with_markup (main_window,
	                                 GTK_DIALOG_DESTROY_WITH_PARENT,
	                                 GTK_MESSAGE_ERROR,
	                                 GTK_BUTTONS_CLOSE,
	                                 _("<b>Error connecting: %s</b>\n\nCheck your network connection and ensure server,mountpoint and password settings are ok!"),
	                                 _(shout_get_error(shout)));
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		shout_close(shout);
		shout_shutdown();
  		gtk_statusbar_pop(statusbar_main, ctxt);
		return;
	} else if (shout_open(shout) == SHOUTERR_SUCCESS) {
		printf("Connected to server...\n");
	} else {
		printf("Error connecting: %s\n", shout_get_error(shout));
	  	GtkWidget *main_window = lookup_widget (GTK_WIDGET (button), "window1");
		GtkWidget *dialog = gtk_message_dialog_new_with_markup (main_window,
	                                 GTK_DIALOG_DESTROY_WITH_PARENT,
	                                 GTK_MESSAGE_ERROR,
	                                 GTK_BUTTONS_CLOSE,
	                                 _("<b>Error connecting: %s</b>\n\nCheck your network connection and ensure server,mountpoint and password settings are ok!"),
	                                 _(shout_get_error(shout)));
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		shout_close(shout);
		shout_shutdown();
  		gtk_statusbar_pop(statusbar_main, ctxt);
		return;
	}

      } else if (mount2) {

	if (!(shout = shout_new())) {
                printf("Could not allocate shout_t\n");
                shout_error=1;
        }

	if (shout_set_host(shout, gtk_entry_get_text (lookup_widget (GTK_WIDGET (button), "entry54"))) != SHOUTERR_SUCCESS) {
                printf("Error setting hostname: %s\n", shout_get_error(shout));
                shout_error=1;
        }

	if (shout_set_protocol(shout, SHOUT_PROTOCOL_HTTP) != SHOUTERR_SUCCESS) {
		printf("Error setting protocol: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	if (shout_set_port(shout, atoi ( gtk_entry_get_text (lookup_widget (GTK_WIDGET (button), "entry55")) ) ) != SHOUTERR_SUCCESS) {
		printf("Error setting port: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	if (shout_set_password(shout, gtk_entry_get_text (lookup_widget (GTK_WIDGET (button), "entry57"))) != SHOUTERR_SUCCESS) {
		printf("Error setting password: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	if (shout_set_mount(shout, gtk_entry_get_text (lookup_widget (GTK_WIDGET (button), "entry56"))) != SHOUTERR_SUCCESS) {
		printf("Error setting mount: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	if (shout_set_user(shout, "source") != SHOUTERR_SUCCESS) {
		printf("Error setting user: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	if (shout_set_format(shout, SHOUT_FORMAT_OGG) != SHOUTERR_SUCCESS) {
		printf("Error setting user: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	if (shout_error==1) {
		printf("Error setting connection params: %s\n", shout_get_error(shout));
	  	GtkWidget *main_window = lookup_widget (GTK_WIDGET (button), "window1");
		GtkWidget *dialog = gtk_message_dialog_new_with_markup (main_window,
	                                 GTK_DIALOG_DESTROY_WITH_PARENT,
	                                 GTK_MESSAGE_ERROR,
	                                 GTK_BUTTONS_CLOSE,
	                                 _("<b>Error connecting on target2: %s</b>\n\nCheck your network connection and ensure server,mountpoint and password settings are ok!"),
	                                 _(shout_get_error(shout)));
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		shout_close(shout);
		shout_shutdown();
  		gtk_statusbar_pop(statusbar_main, ctxt);
		return;
	} else if (shout_open(shout) == SHOUTERR_SUCCESS) {
		printf("Connected to server...\n");
	} else {
		printf("Error connecting: %s\n", shout_get_error(shout));
	  	GtkWidget *main_window = lookup_widget (GTK_WIDGET (button), "window1");
		GtkWidget *dialog = gtk_message_dialog_new_with_markup (main_window,
	                                 GTK_DIALOG_DESTROY_WITH_PARENT,
	                                 GTK_MESSAGE_ERROR,
	                                 GTK_BUTTONS_CLOSE,
	                                 _("<b>Error connecting on target2: %s</b>\n\nCheck your network connection and ensure server,mountpoint and password settings are ok!"),
	                                 _(shout_get_error(shout)));
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		shout_close(shout);
		shout_shutdown();
  		gtk_statusbar_pop(statusbar_main, ctxt);
		return;
	}

      }

	shout_close(shout);
	shout_shutdown();
  	gtk_statusbar_pop(statusbar_main, ctxt);

     }

	/*if we are here that means the connection and server settings (if especified) are ok!!*/




	if (!mount1&&!mount2&&!local1&&!local2) {

	  	GtkWidget *main_window = lookup_widget (GTK_WIDGET (button), "window1");
		GtkWidget *dialog = gtk_message_dialog_new_with_markup (main_window,
	                                 GTK_DIALOG_DESTROY_WITH_PARENT,
	                                 GTK_MESSAGE_ERROR,
	                                 GTK_BUTTONS_CLOSE,
	                                 _("<b>ERROR: cannot start without any target configured.</b>\n\n For a target to be correctly configured fill ALL the icecast server fields or specify a dump filename."));
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);

		active=0;	

	} else { // aixo vol dir que algun target (local o remot) esta configurat i llest per a començar 

	
		/*no ens interessa que s'utilitzi el mount2 sense usar el mount1*/
		if ((mount2||local2)&&(!mount1&&!local1)) {

	  	GtkWidget *main_window = lookup_widget (GTK_WIDGET (button), "window1");
		GtkWidget *dialog = gtk_message_dialog_new_with_markup (main_window,
	                                 GTK_DIALOG_DESTROY_WITH_PARENT,
	                                 GTK_MESSAGE_ERROR,
	                                 GTK_BUTTONS_CLOSE,
	                                 _("<b>ERROR: cannot start without target1 configured.</b>\n\n If you want to use only one target that should be the first one,"));
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);

		active=0;
		return;	

		}


		active=1; // flag global per saber si estem estrimejant o no


	//s'han de crear els pipes si no existeixen
	system ("mkfifo /tmp/tsspiperr1 > /dev/null 2>&1");
	system ("mkfifo /tmp/tsspiperr2 > /dev/null 2>&1");
	system ("mkfifo /tmp/tsspipe1 > /dev/null 2>&1");
	system ("mkfifo /tmp/tsspipe2 > /dev/null 2>&1");
	system ("mkfifo /tmp/tsspipe3 > /dev/null 2>&1");
	system ("mkfifo /tmp/tsspipe4 > /dev/null 2>&1");
	system ("mkfifo /tmp/tsspipe5 > /dev/null 2>&1");
	system ("mkfifo /tmp/tsspipe6 > /dev/null 2>&1");
	system ("mkfifo /tmp/tsspipe7 > /dev/null 2>&1");
	system ("mkfifo /tmp/tsspipe8 > /dev/null 2>&1");

	//obrim el fitxer del script	
	script_file = fopen ("/tmp/tssSTREAM", "w");
	fprintf(script_file,"#!/bin/bash\n");
	fprintf(script_file,"\n");
	fprintf(script_file,"NOW=$( date +\"%%Y%%d%%m-%%H%%M%%S\" ) \n");
	//fprintf(script_file,"set -x\n");
	fprintf(script_file,"\n\n echo \"---------- STARTING -----------\" \n\n");


	/*we want a copy of the video capture command of our script, in order to test video before running the script*/
	char capture_command[1024];
	char test_capture[124];
	system ("rm /tmp/tss_capture_command_test.jpg"); //delete previous checks

	
       //depenent de quins mountpoints s'han configurat, de si s'ha o no de grabar i de si hi ha o no el theora_player haurem de crear el command del dbgrav amb 1,2,3,4 tee's ... i tb depenent d'aixo escriure una comanda per a cada pipe utilitzat 
	
	// SOURCE = DV RAW1394 DEVICE
	toggle = lookup_widget (GTK_WIDGET (button), "checkbutton3");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) { 
		fprintf(script_file,"dvgrab -format raw - ");
		if (mount1 || local1) fprintf(script_file," | tee -a /tmp/tsspipe1");
		if (mount2 || local2) fprintf(script_file," | tee -a /tmp/tsspipe2");
		fprintf(script_file," > /dev/null 2>&1 &\n");

		sprintf(capture_command,"dvgrab -jpeg-over -jpeg-w=160 -jpeg-h=120 -d smtpe=1 /tmp/tss_capture_command_test.jpg");
		sprintf(test_capture,"DV device");

	}
	//TODO autodetect v4l or v4l2 devices
	// SOURCE = V4L or V4L2 DEVICE
	toggle = lookup_widget (GTK_WIDGET (button), "checkbutton2");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) { 
		combo = lookup_widget (GTK_WIDGET (button), "combobox14");
		v4l_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		combo = lookup_widget (GTK_WIDGET (button), "combobox15");
		dsp_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));

		char dummy[256];
		int v4l_version = 0;
		//chek if is a v4l1 or v4l2 device
		int fd = open(v4ldevs[v4l_index],O_RDONLY);
		if (-1 != ioctl(fd,VIDIOC_QUERYCAP,dummy)) { //v4l2
			fprintf(stderr,"this is a v4l2 device\n");
			fprintf(script_file,"ffmpeg -f oss -i %s -f video4linux2 ", dspdevs[dsp_index]);
			v4l_version = 2;
        	} else { //v4l1
			fprintf(stderr,"this is a v4l device\n");
			fprintf(script_file,"ffmpeg -f oss -i %s -f video4linux ", dspdevs[dsp_index]);
			v4l_version = 1;
		}
		close(fd);


		combo = lookup_widget (GTK_WIDGET (button), "combobox7");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file," -s vga -ac 2 -r 25 -i %s  -s 720x576 -ac 2 -ar 48000 -f dv -  ", v4ldevs[v4l_index]);   
		if (mount1 || local1) fprintf(script_file," | tee -a /tmp/tsspipe1");
		if (mount2 || local2) fprintf(script_file," | tee -a /tmp/tsspipe2");
		fprintf(script_file," > /dev/null 2>&1 &\n");

		if (v4l_version == 2) {
			sprintf(capture_command,"ffmpeg -f video4linux2 -s vga -i %s -vframes 1 -ss 2 -y -s 160x120 -f image2 /tmp/tss_capture_command_test.jpg",  v4ldevs[v4l_index]);	
			sprintf(test_capture,"video4linux2 device");
		} else {
			sprintf(capture_command,"ffmpeg -f video4linux -r 60000/1001 -s vga -i %s -vframes 1 -ss 2 -y -s 160x120 -f image2 /tmp/tss_capture_command_test.jpg",  v4ldevs[v4l_index]);	
			sprintf(test_capture,"video4linux device");
		}

	}

	// SOURCE = X11GRAB DEVICE
	toggle = lookup_widget (GTK_WIDGET (button), "checkbutton6");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) { 
		//get bconfigured offset and size
		combo = lookup_widget (GTK_WIDGET (button), "spinbutton23");
		int x11_w = gtk_spin_button_get_value_as_int(combo);
		combo = lookup_widget (GTK_WIDGET (button), "spinbutton24");
		int x11_h = gtk_spin_button_get_value_as_int(combo);
		combo = lookup_widget (GTK_WIDGET (button), "spinbutton21");
		int x11_x = gtk_spin_button_get_value_as_int(combo);
		combo = lookup_widget (GTK_WIDGET (button), "spinbutton22");
		int x11_y = gtk_spin_button_get_value_as_int(combo);
		combo = lookup_widget (GTK_WIDGET (button), "combobox7");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"ffmpeg -f oss -i /dev/dsp -f x11grab -s %dx%d -ac 2 -r 12 -i :0.0+%d,%d  -s 720x576 -ac 2 -ar 48000 -f dv  - ", x11_w, x11_h, x11_x, x11_y, framesizes_ff[active_index]);   
		if (mount1 || local1) fprintf(script_file," | tee -a /tmp/tsspipe1");
		if (mount2 || local2) fprintf(script_file," | tee -a /tmp/tsspipe2");
		fprintf(script_file," > /dev/null 2>&1 &\n");
		sprintf(capture_command,"ffmpeg -f x11grab -s %dx%d -r 12 -i :0.0+%d,%d -vframes 1 -ss 2 -y -f image2 -s %s /tmp/tss_capture_command_test.jpg ", x11_w, x11_h, x11_x, x11_y, framesizes_ff[active_index]);
		sprintf(test_capture,"Screen X11 Grab");
	}

	// SOURCE = LOCAL VIDEO FILE  
	toggle = lookup_widget (GTK_WIDGET (button), "checkbutton4");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) { 
		infile = 1;
		combo = lookup_widget (GTK_WIDGET (button), "combobox7");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		sprintf(capture_command,"ffmpeg -i \"%s\" -vframes 1 -ss 2 -y -f image2 -s %s /tmp/tss_capture_command_test.jpg ", inputfile, framesizes_ff[active_index]);
		sprintf(test_capture,"local video file");
	} else infile = 0;	




	if (mount1 || local1) { 
		if (!infile) fprintf(script_file,"cat /tmp/tsspipe1 | ");
		
		fprintf(script_file,"ffmpeg2theora ");
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) {
			//combo = lookup_widget (GTK_WIDGET (button), "combobox14");
			//active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
			//fprintf(script_file,"--v4l %s ",v4ldevs[active_index]);
			//combo = lookup_widget (GTK_WIDGET (button), "combobox15");
			//active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
			//fprintf(script_file,"--inputfps %i ",inputframerates[active_index]);

		}
		entry = lookup_widget(GTK_WIDGET(button), "entry53");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--artist \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry52");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--title \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry51");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--date \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry50");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--location \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry49");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--organization \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry48");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--copyright \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry47");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--license \"%s\" ",gtest); 
		
		
		
		toggle = lookup_widget (GTK_WIDGET (button), "checkbutton3");
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) fprintf(script_file,"-f dv "); 
		combo = lookup_widget (GTK_WIDGET (button), "combobox7");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"%s ",framesizes[active_index]);
		combo = lookup_widget (GTK_WIDGET (button), "combobox6");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"%s ",framerates[active_index]);
		combo = lookup_widget (GTK_WIDGET (button), "combobox5");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-v %i ",active_index);
		combo = lookup_widget (GTK_WIDGET (button), "combobox4");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-a %i ",(active_index-2));
		combo = lookup_widget (GTK_WIDGET (button), "combobox3");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-c %i ",active_index+1);
		combo = lookup_widget (GTK_WIDGET (button), "combobox2");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-H %i ",samplerates[active_index]);
		combo = lookup_widget (GTK_WIDGET (button), "combobox_speedlevel");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"--speedlevel %i ",active_index);
		combo = lookup_widget (GTK_WIDGET (button), "combobox_vbps");
		active_index = gtk_spin_button_get_value_as_int(combo);
		if (active_index > 0) fprintf(script_file,"-V %i ",active_index);
		combo = lookup_widget (GTK_WIDGET (button), "combobox_abps");
		active_index = gtk_spin_button_get_value_as_int(combo);
		if (active_index > 0) fprintf(script_file,"-A %i ",active_index);
	        //fprintf(script_file,"-o /tmp/tsspipe3 - 2>/tmp/tsspiperr1 &\n");
	        fprintf(script_file,"-o /tmp/tsspipe3 ");
		if (!infile) fprintf(script_file,"- &\n");
		else fprintf(script_file,"\"%s\" &\n", inputfile);
		fprintf(script_file,"cat /tmp/tsspipe3 ");
		

		//toggle = lookup_widget (GTK_WIDGET (button), "checkbutton4");
		//if (gtk_toggle_button_get_active(GTK_CHECK_BUTTON(toggle)) ) fprintf(script_file," tee -a /tmp/tsspipe4 |");
		toggle = lookup_widget (GTK_WIDGET (button), "checkbutton5");
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) fprintf(script_file,"| tee /tmp/tsspipe4 ");


		if (local1) fprintf(script_file," | tee %s$NOW.ogg ",localfile1);
		if (mount1) {
			fprintf(script_file," | oggfwd ");

			entry = lookup_widget(GTK_WIDGET(button), "entry46");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-d \"%s\" ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry45");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-g \"%s\" ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry44");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-n \"%s\" ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry43");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-u \"%s\" ",gtest);


		
			entry = lookup_widget(GTK_WIDGET(button), "entry39");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry40");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry42");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry41");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
		}
		else fprintf(script_file," > /dev/null 2>&1 ");
		//toggle = lookup_widget (GTK_WIDGET (button), "checkbutton4");
		//if (gtk_toggle_button_get_active(GTK_CHECK_BUTTON(toggle)) )  fprintf(script_file,"cat /tmp/tsspipe4 | /usr/bin/tss_player&\n");
		
		toggle = lookup_widget (GTK_WIDGET (button), "checkbutton5");
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) fprintf(script_file,"&\n\ncat /tmp/tsspipe4 | aoss tss_player > /dev/null 2>&1");
	
	}
	if (mount2 || local2) fprintf(script_file," & \n");
        else fprintf(script_file," \n");

	fprintf(script_file,"\n");
	
	
	
	
	toggle = lookup_widget (GTK_WIDGET (button), "checkbutton2");
	
	if (mount2 || local2) { 
		if (!infile) fprintf(script_file,"cat /tmp/tsspipe2 | ");
		
		fprintf(script_file,"ffmpeg2theora ");

		entry = lookup_widget(GTK_WIDGET(button), "entry64");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--artist \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry63");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--title \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry62");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--date \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry61");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--location \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry60");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--organization \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry59");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--copyright \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry58");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--license \"%s\" ",gtest); 
		
		
		
		toggle = lookup_widget (GTK_WIDGET (button), "checkbutton3");
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) fprintf(script_file,"-f dv "); 
		combo = lookup_widget (GTK_WIDGET (button), "combobox13");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"%s ",framesizes[active_index]);
		combo = lookup_widget (GTK_WIDGET (button), "combobox12");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"%s ",framerates[active_index]);
		combo = lookup_widget (GTK_WIDGET (button), "combobox11");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-v %i ",active_index);
		combo = lookup_widget (GTK_WIDGET (button), "combobox10");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-a %i ",(active_index-2));
		combo = lookup_widget (GTK_WIDGET (button), "combobox9");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-c %i ",active_index+1);
		combo = lookup_widget (GTK_WIDGET (button), "combobox8");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-H %i ",samplerates[active_index]);
		combo = lookup_widget (GTK_WIDGET (button), "combobox_speedlevel2");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"--speedlevel %i ",active_index);
		combo = lookup_widget (GTK_WIDGET (button), "combobox_vbps2");
		active_index = gtk_spin_button_get_value_as_int(combo);
		if (active_index > 0) fprintf(script_file,"-V %i ",active_index);
		combo = lookup_widget (GTK_WIDGET (button), "combobox_abps2");
		active_index = gtk_spin_button_get_value_as_int(combo);
		if (active_index > 0) fprintf(script_file,"-A %i ",active_index);




				
		//fprintf(script_file,"-o /tmp/tsspipe6 - 2>/tmp/tsspiperr2 &\n");
		fprintf(script_file,"-o /tmp/tsspipe6 ");
		if (!infile) fprintf(script_file,"- &\n");
		else fprintf(script_file,"%s &\n", inputfile);
		
		fprintf(script_file,"cat /tmp/tsspipe6 ");
		//if (preview2) fprintf(script_file," tee -a /tmp/tsspipe7 |");
		if (local2) fprintf(script_file," | tee %s$NOW.ogg ",localfile2);
		if (mount2) {
			
			fprintf(script_file," | oggfwd ");


			entry = lookup_widget(GTK_WIDGET(button), "entry68");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-d \"%s\" ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry67");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-g \"%s\" ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry66");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-n \"%s\" ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry65");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-u \"%s\" ",gtest);




			entry = lookup_widget(GTK_WIDGET(button), "entry54");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry55");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry57");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry56");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s \n",gtest);
		}
		else fprintf(script_file," > /dev/null 2>&1 \n");

		
		//if (preview2) fprintf(script_file,"cat /tmp/tsspipe7 | /usr/bin/tss_player&\n");
	
	}
	
	fprintf(script_file,"\n\n echo \"---------- FINISHED -----------\" \n\n");
	fclose (script_file);

	system ("chmod 777 /tmp/tssSTREAM");


	/*before to launch the script check if the video capture command will work properly if not return with an error message*/
  	gtk_statusbar_push(statusbar_main, ctxt, _("checking video capture device ... "));
	
	system(capture_command);
	FILE *fpn;
  	fpn = fopen ("/tmp/tss_capture_command_test.jpg", "r");
  	if (fpn == NULL)
    	{
		printf("Error : video capture command don't work!\n");
	  	GtkWidget *main_window = lookup_widget (GTK_WIDGET (button), "window1");
		GtkWidget *dialog = gtk_message_dialog_new_with_markup (main_window,
	                                 GTK_DIALOG_DESTROY_WITH_PARENT,
	                                 GTK_MESSAGE_ERROR,
	                                 GTK_BUTTONS_CLOSE,
	                                 _("<b>Error getting video from %s</b>\n\nCheck your video device(s) and check source parameters settings. Maybe you need to close some video applications or to re-attach the device, otherwise you can try to use the TSS assistant to check if your video device is supported."),test_capture);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
  		gtk_statusbar_pop(statusbar_main, ctxt);
		return;
	}
  	gtk_statusbar_pop(statusbar_main, ctxt);
	
	/*if the video capture command is checked and secured to work then we can launch the shell script!!!*/	
	entry = lookup_widget(GTK_WIDGET(button), "statusbar1");
	vte_terminal_fork_command ((VteTerminal*)entry,"/tmp/tssSTREAM", NULL, NULL, NULL, FALSE, TRUE, TRUE);


	/* here the script should be running so we can paint the animated icon to visualize activity*/
  	GError *error = NULL;
  	GdkPixbufAnimation *pix = gdk_pixbuf_animation_new_from_file (PACKAGE_DATA_DIR "/tss/pixmaps/spinner.gif", &error);
  	if (pix == NULL) {
  	  	g_printerr ("Error loading spinner file: %s\n", PACKAGE_DATA_DIR "/tss/pixmaps/spinner.gif");
  	  	g_error_free (error);
  	} else {
		GtkWidget *spinner = lookup_widget(GTK_WIDGET(button), "spinner");
		gtk_image_set_from_animation (spinner, pix);
		gtk_widget_show(spinner);
	}

	/*we are running the script so the Exec button became insensible and the Stop button becames sensible*/
	GtkWidget *button1 = lookup_widget(GTK_WIDGET(button), "button1");
	GtkWidget *button2 = lookup_widget(GTK_WIDGET(button), "button2");
	if (mount1||local1) {
		gtk_widget_set_sensitive (GTK_WIDGET (button1), FALSE);
		gtk_widget_set_sensitive (GTK_WIDGET (button2), TRUE);
		if (mount1) {
  			char url[1024];
  			sprintf(url,_("http://%s:%s/%s --- BROADCASTING NOW"), server1, port1, mountpoint1);
  			gtk_statusbar_push(statusbar_main, ctxt, url);
		} else if (mount2) {
  			char url[1024];
  			sprintf(url,_("http://%s:%s/%s  ---  BROADCASTING NOW"), server2, port2, mountpoint2);
  			gtk_statusbar_push(statusbar_main, ctxt, url);
		}else gtk_statusbar_push(statusbar_main, ctxt, _("dumping video to local file"));	
	} 
		    

	if (firsttime==0) {
		  /*gtk_widget_set_size_request (drawing_area, 100, 100);*/
		  //drawingarea1 = lookup_widget(GTK_WIDGET(button), "drawingarea1");
      
		  //g_signal_connect (G_OBJECT (drawingarea1), "expose_event",  
		  //                        G_CALLBACK (expose_event_callback), NULL);
		  /* Start the graph_time_tracker timer, and connect it to the callback */
		  //graph_time_tracker = g_timer_new ();
		  /* Add a timeout to update the drawing area every 100 milliseconds or so */
		  //gint func_ref = g_timeout_add (250, update_graph, drawingarea1);
		  firsttime=1;
	}
	}
}

void
on_vte_child_exited                    (VteTerminal *vteterminal,
                                        gpointer         user_data)
{
	//fprintf(stderr, "vte child exited");
  	GError *error = NULL;
  	GdkPixbufAnimation *pix = gdk_pixbuf_animation_new_from_file (PACKAGE_DATA_DIR "/tss/pixmaps/spinner_off.gif", &error);
  	if (pix == NULL) {
  	  	g_printerr ("Error loading spinner file: %s\n", PACKAGE_DATA_DIR "/tss/pixmaps/spinner_off.gif");
  	  	g_error_free (error);
  	} else {
		GtkWidget *spinner = lookup_widget(GTK_WIDGET(vteterminal), "spinner");
		gtk_image_set_from_animation (spinner, pix);
		gtk_widget_show(spinner);
	}

	/*If we are here it means the script stoped so the Exec button became sensible and the Stop button becames insensible*/
	GtkWidget *button1 = lookup_widget(GTK_WIDGET(vteterminal), "button1");
	GtkWidget *button2 = lookup_widget(GTK_WIDGET(vteterminal), "button2");
  	GtkWidget *statusbar_main = lookup_widget (GTK_WIDGET (vteterminal), "statusbar_main");;
  	guint ctxt = gtk_statusbar_get_context_id (statusbar_main, "salutacio");

	gtk_widget_set_sensitive (GTK_WIDGET (button1), TRUE);
	gtk_widget_set_sensitive (GTK_WIDGET (button2), FALSE);
 	gtk_statusbar_pop(statusbar_main, ctxt);
}

void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  	GtkWidget *statusbar;

	active=0;
  	close (fp);
	//fp = NULL;
	//g_timer_destroy (graph_time_tracker);
	system("killall -9 cat > /dev/null 2>&1");
	system("killall -9 dvgrab > /dev/null 2>&1");
	system("killall -9 ffmpeg > /dev/null 2>&1");
	system("killall -9 ffmpeg2theora > /dev/null 2>&1");
	system("killall -9 oggfwd > /dev/null 2>&1");
	system("killall -9 tss_player > /dev/null 2>&1");
	statusbar = lookup_widget(GTK_WIDGET(button), "statusbar1");
  	char *env[] = {"PATH=/usr/bin:/bin:./usr/local/bin:/bin", NULL};
  	char *params[] = {"/bin/sh", "-c", "echo \"\n\n---------- FINISHED -----------\n\n\"" ,NULL};
  	vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params, env, NULL, FALSE, TRUE, TRUE);

  	GError *error = NULL;
  	GdkPixbufAnimation *pix = gdk_pixbuf_animation_new_from_file (PACKAGE_DATA_DIR "/tss/pixmaps/spinner_off.gif", &error);
  	if (pix == NULL) {
  	  	g_printerr ("Error loading spinner file: %s\n", PACKAGE_DATA_DIR "/tss/pixmaps/spinner_off.gif");
  	  	g_error_free (error);
  	} else {
		GtkWidget *spinner = lookup_widget(GTK_WIDGET(button), "spinner");
		gtk_image_set_from_animation (spinner, pix);
		gtk_widget_show(spinner);
	}

	/*we are killing the script so the Exec button became sensible and the Stop button becames insensible*/
	GtkWidget *button1 = lookup_widget(GTK_WIDGET(button), "button1");
	GtkWidget *button2 = lookup_widget(GTK_WIDGET(button), "button2");
  	GtkWidget *statusbar_main = lookup_widget (GTK_WIDGET (button), "statusbar_main");;
  	guint ctxt = gtk_statusbar_get_context_id (statusbar_main, "salutacio");

	gtk_widget_set_sensitive (GTK_WIDGET (button1), TRUE);
	gtk_widget_set_sensitive (GTK_WIDGET (button2), FALSE);
 	gtk_statusbar_pop(statusbar_main, ctxt);


}







void
on_entry1_insert_text                  (GtkEditable     *editable,
                                        gchar           *new_text,
                                        gint             new_text_length,
                                        gpointer         position,
                                        gpointer         user_data)
{

	
}


void
on_entry1_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{

}

void
on_target1_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
	GtkWidget *entry;
	gchar *server1, *port1, *pass1, *mountpoint1, *localfile1, *button1;
	int mount1 = 0;
	int local1 = 0;
	entry = lookup_widget(GTK_WIDGET(editable), "entry39");
	server1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(editable), "entry40");
	port1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(editable), "entry41");
	mountpoint1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(editable), "entry42");
	pass1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(editable), "entry80");
	localfile1= gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	
	if ((strlen(server1) > 5) && (strlen(port1)  > 1) && (strlen(pass1) > 1) && (strlen(mountpoint1) > 4)) mount1 = 1;
	else mount1 = 0;	

	if (strlen(localfile1) > 1) local1 = 1;	
	else local1 = 0;	

	button1 = lookup_widget(GTK_WIDGET(editable), "button1");
  	GtkWidget *statusbar_main = lookup_widget (GTK_WIDGET (editable), "statusbar_main");;
  	guint ctxt = gtk_statusbar_get_context_id (statusbar_main, "salutacio");
	if (mount1||local1) {
		gtk_widget_set_sensitive (GTK_WIDGET (button1), TRUE);
		if (mount1) {
  			char url[1024];
  			sprintf(url,_("http://%s:%s/%s is ready but not streaming now"), server1, port1, mountpoint1);
  			gtk_statusbar_push(statusbar_main, ctxt, url);
		} else gtk_statusbar_push(statusbar_main, ctxt, "");	
	} else { 
		gtk_widget_set_sensitive (GTK_WIDGET (button1), FALSE);
		gtk_statusbar_push(statusbar_main, ctxt, "");
	}
}


void
on_new1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (menuitem), "window1");
  open_file (main_window);
	
}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (menuitem), "window1");

  /* If the current document doesn't have a filename yet, we call save_as
     to show the file selection dialog. */
  if (current_filename == NULL)
    save_as (main_window);
  else
    real_save_file (main_window, current_filename);

}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (menuitem), "window1");
  save_as (main_window);

}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
 system ("rm /tmp/tssSTREAM > /dev/null 2>&1");
 system ("rm /tmp/tss_thumbnail_*.jpg > /dev/null 2>&1");
 system ("rm /tmp/tsspipe* > /dev/null 2>&1");
 system ("rm /tmp/tss_capture_command_test.jpg"); //delete previous checks
 exit (0);
}

void
on_advancedview_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *notebook = lookup_widget (GTK_WIDGET (menuitem), "notebook1");
  GtkWidget *statusbar = lookup_widget (GTK_WIDGET (menuitem), "alignment3");
  gtk_widget_show (notebook);
  gtk_widget_show (statusbar);
  GtkWidget *window = lookup_widget (GTK_WIDGET (menuitem), "window1");
  gtk_widget_set_size_request(GTK_WIDGET (window),720,600);
  gtk_window_resize(GTK_WINDOW (window),720,600);
}

void
on_simpleview_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *notebook = lookup_widget (GTK_WIDGET (menuitem), "notebook1");
  GtkWidget *statusbar = lookup_widget (GTK_WIDGET (menuitem), "alignment3");
  gtk_widget_hide (notebook);
  gtk_widget_hide (statusbar);
  GtkWidget *window = lookup_widget (GTK_WIDGET (menuitem), "window1");
  gtk_widget_set_size_request(GTK_WIDGET (window),720,131);
  gtk_window_resize(GTK_WINDOW (window),720,131);
}

void
go_simpleview          (GtkWidget     *menuitem)
{
  GtkWidget *notebook = lookup_widget (GTK_WIDGET (menuitem), "notebook1");
  GtkWidget *statusbar = lookup_widget (GTK_WIDGET (menuitem), "alignment3");
  gtk_widget_hide (notebook);
  gtk_widget_hide (statusbar);
  GtkWidget *window = lookup_widget (GTK_WIDGET (menuitem), "window1");
  gtk_widget_set_size_request(GTK_WIDGET (window),720,120);
  gtk_window_resize(GTK_WINDOW (window),720,120);
}


void
on_assistantstart_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (menuitem), "window1");
  /* We use the same file selection widget each time, so first
     of all we create it if it hasn't already been created. */
  if (assistant == NULL)
    {
      assistant = create_assistantdialog ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (assistant), 
				    GTK_WINDOW (main_window));
    }

  /* We save a pointer to the main window inside the file selection's
     data list, so we can get it easily in the callbacks. */
  gtk_object_set_data (GTK_OBJECT (assistant), MainWindowKey, main_window);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (assistant));

}


void
go_assistant          (GtkWidget     *menuitem)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (menuitem), "window1");
  /* We use the same file selection widget each time, so first
     of all we create it if it hasn't already been created. */
  if (assistant == NULL)
    {
      assistant = create_assistantdialog ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (assistant), 
				    GTK_WINDOW (main_window));
    }

  /* We save a pointer to the main window inside the file selection's
     data list, so we can get it easily in the callbacks. */
  gtk_object_set_data (GTK_OBJECT (assistant), MainWindowKey, main_window);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (assistant));

}

void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (menuitem), "window1");
  /* We use the same file selection widget each time, so first
     of all we create it if it hasn't already been created. */
  //if (about == NULL)
    {
      about = create_aboutdialog1 ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (about), 
				    GTK_WINDOW (main_window));
    }

  /* We save a pointer to the main window inside the file selection's
     data list, so we can get it easily in the callbacks. */
  gtk_object_set_data (GTK_OBJECT (about), MainWindowKey, main_window);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (about));
	
  gtk_dialog_run (GTK_DIALOG (about)); 
  gtk_widget_destroy (about);

}






/* This sets the window title according to the current filename. */
void
set_window_title (GtkWidget *main_window)
{
  gchar *title, *filename_utf8 = NULL;

  /* We need to convert the filename to UTF-8. */
  if (current_filename)
    filename_utf8 = g_filename_to_utf8 (current_filename, -1, NULL, NULL,
					NULL);

  title = g_strdup_printf ("tss: %s\n",
			   filename_utf8 ? g_basename (filename_utf8)
			   : "untitled");

  gtk_window_set_title (GTK_WINDOW (main_window), title);
  g_free (title);
  g_free (filename_utf8);
}


/* This creates a new document, by clearing the text widget and setting the
   current filename to NULL. */
static void
new_file (GtkWidget *main_window)
{
  GtkWidget *text, *statusbar;
  GtkTextBuffer *buffer;
  GtkTextIter start, end;

  text = lookup_widget (GTK_WIDGET (main_window), "text1");
  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text));
  gtk_text_buffer_get_bounds (buffer, &start, &end);
  gtk_text_buffer_delete (buffer, &start, &end);

  g_free (current_filename);
  current_filename = NULL;
  file_changed = FALSE;
  set_window_title (main_window);

  statusbar = lookup_widget (main_window, "statusbar1");
  char *env[] = {"PATH=/usr/bin:/bin:./usr/local/bin:/bin", NULL};
  char *params[] = {"/bin/sh", "-c", "\n\nNew file ... \n" ,NULL};
  vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params, env, NULL, FALSE, TRUE, TRUE);
}






/* This shows the file selection dialog to open a file. */
static void
open_infile (GtkWidget *main_window)
{
  /* We use the same file selection widget each time, so first
     of all we create it if it hasn't already been created. */
  if (open_infilesel == NULL)
    {
      open_infilesel = create_filechooserdialog3 ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (open_infilesel), 
				    GTK_WINDOW (main_window));
    }

  /* We save a pointer to the main window inside the file selection's
     data list, so we can get it easily in the callbacks. */
  gtk_object_set_data (GTK_OBJECT (open_infilesel), MainWindowKey, main_window);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (open_infilesel));
}



/* This shows the file selection dialog to open a file. */
static void
open_file (GtkWidget *main_window)
{
  /* We use the same file selection widget each time, so first
     of all we create it if it hasn't already been created. */
  if (open_filesel == NULL)
    {
      open_filesel = create_filechooserdialog1 ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (open_filesel), 
				    GTK_WINDOW (main_window));
    }

  /* We save a pointer to the main window inside the file selection's
     data list, so we can get it easily in the callbacks. */
  gtk_object_set_data (GTK_OBJECT (open_filesel), MainWindowKey, main_window);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (open_filesel));
}


/* This shows the file selection dialog to save a file. */
static void
save_as (GtkWidget *main_window)
{
  if (save_filesel == NULL)
    {
      save_filesel = create_filechooserdialog2 ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (save_filesel), 
				    GTK_WINDOW (main_window));
    }

  gtk_object_set_data (GTK_OBJECT (save_filesel), MainWindowKey, main_window);


  /* If the current document has a filename we use that as the default. */
  //if (current_filename)
  //  gtk_file_selection_set_filename (GTK_FILE_CHOOSER (save_filesel),
  //				     current_filename);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (save_filesel));
}

void
on_button5_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));

}


void
on_button6_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *filesel, *main_window;
  const gchar *filename;

  filesel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  main_window = gtk_object_get_data (GTK_OBJECT (filesel), MainWindowKey);
  if (gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel)) != NULL ) {
  	gtk_widget_hide (filesel);
  	filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel));
  	real_open_file (main_window, filename);
  }

}


void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));

}


/*exit from the "save as" menu */
void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *filesel, *main_window;
  const gchar *filename;

  filesel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  main_window = gtk_object_get_data (GTK_OBJECT (filesel), MainWindowKey);
  if (gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel)) != NULL ) {
  	gtk_widget_hide (filesel);
  	filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel));
  	real_save_file (main_window, filename);
  }

}




/* This loads the given file, which is in on-disk encoding (which may not
   be UTF-8). */
static void
real_open_infile (GtkWidget *main_window, const gchar *filename)
{
  GtkWidget *entry;
  GtkWidget *toggle;
  gchar data[BUFFER_SIZE];
  gint pos=0;

    entry = lookup_widget(GTK_WIDGET(main_window), "entry82");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), filename, strlen(filename), &pos);

    toggle = lookup_widget (GTK_WIDGET (main_window), "checkbutton4");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),1);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),1);
}






/* This loads the given file, which is in on-disk encoding (which may not
   be UTF-8). */
void
real_open_file (GtkWidget *main_window, const gchar *filename)
{
  GtkWidget *entry, *statusbar;
  FILE *fpn;
  gchar buffer[BUFFER_SIZE], data[BUFFER_SIZE];
  gchar *match,*value;
  gint bytes_read, active_index, pos=0;
  char message[256] = "";
  char *env[] = {"PATH=/usr/bin:/bin:./usr/local/bin:/bin", NULL};

  statusbar = lookup_widget (main_window, "statusbar1");
  //gtk_statusbar_pop (GTK_STATUSBAR (statusbar), 1);
  g_free (current_filename);
  current_filename = NULL;
  file_changed = FALSE;

  fpn = fopen (filename, "r");
  if (fpn == NULL)
    {
	  strcat (message, "echo \"\n\nERROR: Couldn't open Configuration File ");
	  strcat (message, filename);
	  strcat (message, " ... \n\"");
	  char *params_ok[] = {"/bin/sh", "-c", message ,NULL};
	  vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params_ok, env, NULL, FALSE, TRUE, TRUE);
      return;
    }

  for (;;)
    {
      bytes_read = fread (buffer, sizeof (gchar), BUFFER_SIZE, fpn);

      if (bytes_read > 0)
	{
	// si llegin quelcom
	
	}

      if (bytes_read != BUFFER_SIZE && (feof (fpn) || ferror (fpn)))
	break;
    }

  /* If there is an error while loading, we reset everything to a good state.
   */
  if (ferror (fpn))
    {
      fclose (fpn);
      set_window_title (main_window);
	  strcat (message, "echo \"\n\nERROR: Couldn't open Configuration File ");
	  strcat (message, filename);
	  strcat (message, " ... \n\"");
	  char *params_ok[] = {"/bin/sh", "-c", message ,NULL};
	  vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params_ok, env, NULL, FALSE, TRUE, TRUE);
      return;
    }

  fclose (fpn);

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "server1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "server1: %s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry39");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "port1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "port1: %s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry40");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "mountpoint1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "mountpoint1: %s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry41");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "password1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "password1: %s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry42");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "framesize1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "framesize1: %d\n", &active_index);
    entry = lookup_widget(GTK_WIDGET(main_window), "combobox7");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),active_index);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "framerate1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "framerate1: %d\n", &active_index);
    entry = lookup_widget(GTK_WIDGET(main_window), "combobox6");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),active_index);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "vquality1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "vquality1: %d\n", &active_index);
    entry = lookup_widget(GTK_WIDGET(main_window), "combobox5");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),active_index);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "aquality1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "aquality1: %d\n", &active_index);
    entry = lookup_widget(GTK_WIDGET(main_window), "combobox4");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),active_index);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "achannels1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "achannels1: %d\n", &active_index);
    entry = lookup_widget(GTK_WIDGET(main_window), "combobox3");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),active_index);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "samplerate1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "samplerate1: %d\n", &active_index);
    entry = lookup_widget(GTK_WIDGET(main_window), "combobox2");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),active_index);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "artist1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "artist1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry53");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "title1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "title1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry52");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "date1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "date1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry51");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "location1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "location1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry50");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "organization1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "organization1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry49");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "copyright1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "copyright1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry48");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "license1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "license1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry47");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "description1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "description1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry46");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "genre1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "genre1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry45");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "name1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "name1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry44");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "url1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "url1: %s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry43");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }
  
  current_filename = g_strdup (filename);
  set_window_title (main_window);
  strcat (message, "echo \"\n\nConfiguration File ");
  strcat (message, filename);
  strcat (message, " correctly loaded ... \n\"");
  char *params_ok[] = {"/bin/sh", "-c", message ,NULL};
  vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params_ok, env, NULL, FALSE, TRUE, TRUE);

  GtkWidget *statusbar_main = lookup_widget (GTK_WIDGET (main_window), "statusbar_main");;
  guint ctxt = gtk_statusbar_get_context_id (statusbar_main, "salutacio");
  char url[1024];
  sprintf(url,_("Configuration File %s correctly loaded ..."), filename);
  gtk_statusbar_push(statusbar_main, ctxt, url);

	gchar *server1, *port1, *pass1, *mountpoint1, *localfile1, *button1;
	int mount1 = 0;
	int local1 = 0;
	entry = lookup_widget(GTK_WIDGET(main_window), "entry39");
	server1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(main_window), "entry40");
	port1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(main_window), "entry41");
	mountpoint1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(main_window), "entry42");
	pass1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(main_window), "entry80");
	localfile1= gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	
	if ((strlen(server1) > 5) && (strlen(port1)  > 1) && (strlen(pass1) > 1) && (strlen(mountpoint1) > 4)) mount1 = 1;
	else mount1 = 0;	

	if (strlen(localfile1) > 1) local1 = 1;	
	else local1 = 0;	

	button1 = lookup_widget(GTK_WIDGET(main_window), "button1");
	if (mount1||local1) {
		gtk_widget_set_sensitive (GTK_WIDGET (button1), TRUE);
		if (mount1) {
  			char url[1024];
  			sprintf(url,_("http://%s:%s/%s is ready but not streaming now"), server1, port1, mountpoint1);
  			gtk_statusbar_push(statusbar_main, ctxt, url);
		} else gtk_statusbar_push(statusbar_main, ctxt, "");	
	} else { 
		gtk_widget_set_sensitive (GTK_WIDGET (button1), FALSE);
		gtk_statusbar_push(statusbar_main, ctxt, "");
	}

}


/* This saves the file, which is in on-disk encoding (which may not be UTF-8). */
static void
real_save_file (GtkWidget *main_window, const gchar *filename)
{
  GtkWidget *entry, *statusbar;
  gchar *data;
  FILE *fp2;
  gint bytes_written, len, active_index;
  char *env[] = {"PATH=/usr/bin:/bin:./usr/local/bin:/bin", NULL};
  char message[256] = "";


  if (current_filename == NULL || strcmp (current_filename, filename))
    {
      g_free (current_filename);
      current_filename = g_strdup (filename);
      set_window_title (main_window);
    }

  statusbar = lookup_widget (main_window, "statusbar1");


  fp2 = fopen (filename, "w");
  if (fp2 == NULL)
    {
      return;
    }

  entry = lookup_widget(GTK_WIDGET(main_window), "entry39");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"server1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry40");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"port1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry41");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"mountpoint1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry42");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"password1: %s\n",data);
		
  entry = lookup_widget (GTK_WIDGET (main_window), "combobox7");
  active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(entry));
  fprintf(fp2,"framesize1: %d\n",active_index);
		
  entry = lookup_widget (GTK_WIDGET (main_window), "combobox6");
  active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(entry));
  fprintf(fp2,"framerate1: %d\n",active_index);
		
  entry = lookup_widget (GTK_WIDGET (main_window), "combobox5");
  active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(entry));
  fprintf(fp2,"vquality1: %d\n",active_index);
		
  entry = lookup_widget (GTK_WIDGET (main_window), "combobox4");
  active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(entry));
  fprintf(fp2,"aquality1: %d\n",active_index);
		
  entry = lookup_widget (GTK_WIDGET (main_window), "combobox3");
  active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(entry));
  fprintf(fp2,"achannels1: %d\n",active_index);
		
  entry = lookup_widget (GTK_WIDGET (main_window), "combobox2");
  active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(entry));
  fprintf(fp2,"samplerate1: %d\n",active_index);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry53");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"artist1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry52");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"title1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry51");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"date1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry50");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"location1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry49");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"organization1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry48");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"copyright1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry47");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"license1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry46");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"description1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry45");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"genre1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry44");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"name1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry43");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"url1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry80");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"dump1: %s\n",data);
  
  
  
  
  fclose (fp2);

  g_free (data);

  if (len != bytes_written)
    {
	  strcat (message, "echo \"\n\nERROR: Couldn't open Configuration File ");
	  strcat (message, filename);
	  strcat (message, " ... \n\"");
	  char *params[] = {"/bin/sh", "-c", message ,NULL};
	  vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params, env, NULL, FALSE, TRUE, TRUE);
      return;
    }

  file_changed = FALSE;
  strcat (message, "echo \"\n\nConfiguration File ");
  strcat (message, filename);
  strcat (message, " correctly saved ... \n\"");
  char *params_saved[] = {"/bin/sh", "-c", message ,NULL};
  vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params_saved, env, NULL, FALSE, TRUE, TRUE);
}


void
on_button9_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (button), "window1");
  open_infile (main_window);

}



void
on_button10_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));

}


void
on_button11_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *filesel, *main_window;
  const gchar *filename;

  filesel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  main_window = gtk_object_get_data (GTK_OBJECT (filesel), MainWindowKey);
  if (gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel)) != NULL ) {
	  gtk_widget_hide (filesel);
	  filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel));
	  real_open_infile (main_window, filename);
  }

}


void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
 system ("rm /tmp/tssSTREAM > /dev/null 2>&1");
 system ("rm /tmp/tss_thumbnail_*.jpg > /dev/null 2>&1");
 system ("rm /tmp/tsspipe* > /dev/null 2>&1");
 system ("rm /tmp/tss_capture_command_test.jpg"); //delete previous checks
 exit (0);
}


void
on_window1_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
  GtkWidget *main_window, *entry;

  //fprintf(stderr,"on_window1_show\n");
  main_window = gtk_widget_get_toplevel (GTK_WIDGET (widget));

    entry = lookup_widget(GTK_WIDGET(main_window), "combobox1");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),0);
    //entry = lookup_widget(GTK_WIDGET(main_window), "combobox14");
    //gtk_combo_box_set_active(GTK_COMBO_BOX(entry),1);
    //entry = lookup_widget(GTK_WIDGET(main_window), "combobox15");
    //gtk_combo_box_set_active(GTK_COMBO_BOX(entry),0);
	
    entry = lookup_widget (GTK_WIDGET (main_window), "checkbutton3");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry),1);


  real_open_file (main_window, PACKAGE_DATA_DIR "/tss/defaultsettings");
 
}


void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (button), "window1");

  if (save_outfile1sel == NULL)
    {
      save_outfile1sel = create_filechooserdialog4 ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (save_outfile1sel), 
				    GTK_WINDOW (main_window));
    }

  gtk_object_set_data (GTK_OBJECT (save_outfile1sel), MainWindowKey, main_window);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (save_outfile1sel));

}


void
on_button4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (button), "window1");

  if (save_outfile2sel == NULL)
    {
      save_outfile2sel = create_filechooserdialog5 ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (save_outfile2sel), 
				    GTK_WINDOW (main_window));
    }

  gtk_object_set_data (GTK_OBJECT (save_outfile2sel), MainWindowKey, main_window);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (save_outfile2sel));

}


void
on_button13_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *filesel, *main_window, *entry;
  const gchar *filename;
  gint pos=0;

  filesel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  main_window = gtk_object_get_data (GTK_OBJECT (filesel), MainWindowKey);
  if (gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel)) != NULL ) {
  	gtk_widget_hide (filesel);
  	filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel));

    	entry = lookup_widget(GTK_WIDGET(main_window), "entry80");
    	gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    	gtk_editable_insert_text(GTK_EDITABLE(entry), filename, strlen(filename), &pos);
  }
}


void
on_button15_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *filesel, *main_window, *entry;
  const gchar *filename;
  gint pos=0;

  filesel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  main_window = gtk_object_get_data (GTK_OBJECT (filesel), MainWindowKey);
  if (gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel)) != NULL ) {
  	gtk_widget_hide (filesel);
  	filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel));

    	entry = lookup_widget(GTK_WIDGET(main_window), "entry81");
    	gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    	gtk_editable_insert_text(GTK_EDITABLE(entry), filename, strlen(filename), &pos);
  }
}


void
on_button12_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));

}


void
on_button14_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));

}



///assistant stuff

/* If there is text in the GtkEntry, set the page as complete. Otherwise,
 * stop the user from progressing the next page. */
void
assistant_entry_changed (GtkEditable *entry,
               GtkAssistant *assistant)
{
  GtkWidget *server_entry = lookup_widget (GTK_WIDGET (entry), "server_entry");
  GtkWidget *port_entry = lookup_widget (GTK_WIDGET (entry), "port_entry");
  GtkWidget *mount_entry = lookup_widget (GTK_WIDGET (entry), "mount_entry");
  GtkWidget *pass_entry = lookup_widget (GTK_WIDGET (entry), "pass_entry");
  const gchar *server_text = gtk_entry_get_text (GTK_ENTRY (server_entry));
  const gchar *port_text = gtk_entry_get_text (GTK_ENTRY (port_entry));
  const gchar *mount_text = gtk_entry_get_text (GTK_ENTRY (mount_entry));
  const gchar *pass_text = gtk_entry_get_text (GTK_ENTRY (pass_entry));

  gint num = gtk_assistant_get_current_page (assistant);
  GtkWidget *page = gtk_assistant_get_nth_page (assistant, num);
  gtk_assistant_set_page_complete (assistant, page, (strlen (server_text) > 0)&&(strlen (port_text) > 0)&&(strlen (mount_text) > 0)&&(strlen (pass_text) > 0) );
}

void
assistant_profile_changed (GtkEditable *combobox,
               GtkAssistant *assistant)
{
	const char*servers[4] = {"","giss.tv","giss.tv","stream.hangar.org"};
	const char*ports[4] = {"","8000","8000","8000"};
	int index = gtk_combo_box_get_active(GTK_COMBO_BOX(combobox));

  	GtkWidget *server_entry = lookup_widget (GTK_WIDGET (combobox), "server_entry");
	gtk_entry_set_text (server_entry, servers[index]);
  	GtkWidget *port_entry = lookup_widget (GTK_WIDGET (combobox), "port_entry");
	gtk_entry_set_text (port_entry,"8000");
	if (index == 2) {
  		GtkWidget *mount_label = lookup_widget (GTK_WIDGET (combobox), "mount_label");
		gtk_label_set_text (mount_label,_("Col·lectiu"));
	}
}



/* If the check button is toggled, set the page as complete. Otherwise,
 * stop the user from progressing the next page. */
void
assistant_button_toggled (GtkCheckButton *toggle,
                GtkAssistant *assistant)
{
  gboolean active = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (toggle));
  gtk_assistant_set_page_complete (assistant, GTK_WIDGET (toggle), active);
}
void
assistant_video_checkbutton_toggled (GtkCheckButton *toggle,
                GtkAssistant *assistant)
{
	int this = gtk_object_get_data (toggle,"ident");
	//fprintf(stderr,"device selected %d",this);
	assistant_device_selection = this; //global var

  	gint num = gtk_assistant_get_current_page (assistant);
  	GtkWidget *page = gtk_assistant_get_nth_page (assistant, num);
  	gtk_assistant_set_page_complete (assistant, page, TRUE );
}


/* If the dialog is cancelled, delete it from memory and then clean up after
 * the Assistant structure. */
void
assistant_cancel (GtkAssistant *assistant,
                  gpointer data)
{
  //gtk_widget_set_size_request(GTK_WIDGET (assistant),450,150);
  //gtk_window_resize(GTK_WINDOW (assistant),450,150);
  //gtk_widget_destroy (GTK_WIDGET (assistant));
  gtk_widget_hide (assistant);
}

/*this is for the v4l discover procedure, we need ioctl in order to know if a devicxe is V4L1 or V4L2 compliant*/
static int
xioctl                          (int                    fd,
                                 int                    request,
                                 void *                 arg)
{
        int r;

        do r = ioctl (fd, request, arg);
        while (-1 == r && EINTR == errno);

        return r;
}


void
assistant_prepare (GtkAssistant *assistant,
                  gpointer data)
{
  int dev_count=0;
  gint num = gtk_assistant_get_current_page (assistant);
  g_print ("Next!%d\n",num);
	if (num == 2) {

		GtkWidget *win, *label, *w, *vbox;
    guint sid;
    /* create the modal window which warns the user to wait */
    win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_size_request (win, 450, 80);
    gtk_window_set_modal(GTK_WINDOW(win), TRUE);
    gtk_window_set_transient_for (GTK_WINDOW (win), 
				    GTK_WINDOW (assistant));
    gtk_window_set_title(GTK_WINDOW(win), _("Checking server configuration"));
    gtk_window_set_icon_from_file (GTK_WINDOW (win), PACKAGE_DATA_DIR "/tss/pixmaps/icon.bmp", NULL);
    gtk_container_set_border_width(GTK_CONTAINER(win), 12);
    g_signal_connect(win, "delete_event", G_CALLBACK(gtk_true), NULL);
    vbox = gtk_vbox_new(FALSE, 12);
    gtk_widget_show(vbox);
    /* create label */
    label = gtk_label_new("Please wait...");
    gtk_widget_show(label);
    gtk_container_add(GTK_CONTAINER(vbox), label);
    /* create progress bar */
    w = gtk_progress_bar_new();
    gtk_widget_show(w);
    gtk_container_add(GTK_CONTAINER(vbox), w);
    /* add vbox to dialog */
    gtk_container_add(GTK_CONTAINER(win), vbox);
    gtk_widget_show (win);
  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (win));

	int shout_error=0; 

	shout_t *shout;
	shout_init();

	if (!(shout = shout_new())) {
                printf("Could not allocate shout_t\n");
                shout_error=1;
        }

	gtk_progress_bar_pulse (w);
	while (gtk_events_pending ())
      		gtk_main_iteration ();
        g_usleep (250000);
	gtk_progress_bar_set_text(w,"setting hostname");

	if (shout_set_host(shout, gtk_entry_get_text (lookup_widget (GTK_WIDGET (assistant), "server_entry"))) != SHOUTERR_SUCCESS) {
                printf("Error setting hostname: %s\n", shout_get_error(shout));
                shout_error=1;
        }

	gtk_progress_bar_pulse (w);
	while (gtk_events_pending ())
      		gtk_main_iteration ();
        g_usleep (250000);
	gtk_progress_bar_set_text(w,"setting protocol");

	if (shout_set_protocol(shout, SHOUT_PROTOCOL_HTTP) != SHOUTERR_SUCCESS) {
		printf("Error setting protocol: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	gtk_progress_bar_pulse (w);
	while (gtk_events_pending ())
      		gtk_main_iteration ();
        g_usleep (250000);
	gtk_progress_bar_set_text(w,"setting port");

	if (shout_set_port(shout, gtk_spin_button_get_value_as_int (lookup_widget (GTK_WIDGET (assistant), "port_entry"))) != SHOUTERR_SUCCESS) {
		printf("Error setting port: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	gtk_progress_bar_pulse (w);
	while (gtk_events_pending ())
      		gtk_main_iteration ();
        g_usleep (250000);
	gtk_progress_bar_set_text(w,"setting passwd");

	if (shout_set_password(shout, gtk_entry_get_text (lookup_widget (GTK_WIDGET (assistant), "pass_entry"))) != SHOUTERR_SUCCESS) {
		printf("Error setting password: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	gtk_progress_bar_pulse (w);
	while (gtk_events_pending ())
      		gtk_main_iteration ();
        g_usleep (250000);
	gtk_progress_bar_set_text(w,"setting mount");
  
	GtkWidget *profile_combobox = lookup_widget(GTK_WIDGET(assistant), "profile_combobox");
  	int index = gtk_combo_box_get_active(GTK_COMBO_BOX(profile_combobox));
	char mountpoint[256];
  	if (index == 2) {
		sprintf(mountpoint,"generatech_%s.ogg",gtk_entry_get_text (lookup_widget (GTK_WIDGET (assistant), "mount_entry")));
  	} else {
		sprintf(mountpoint,"%s",gtk_entry_get_text (lookup_widget (GTK_WIDGET (assistant), "mount_entry")));
	}
		//fprintf(stderr,"\n%s\n",mountpoint);
	
	if (shout_set_mount(shout, mountpoint) != SHOUTERR_SUCCESS) {
		printf("Error setting mount: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	gtk_progress_bar_pulse (w);
	while (gtk_events_pending ())
      		gtk_main_iteration ();
        g_usleep (250000);
	gtk_progress_bar_set_text(w,"setting user");

	if (shout_set_user(shout, "source") != SHOUTERR_SUCCESS) {
		printf("Error setting user: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	gtk_progress_bar_pulse (w);
	while (gtk_events_pending ())
      		gtk_main_iteration ();
        g_usleep (250000);
	gtk_progress_bar_set_text(w,"setting format");

	if (shout_set_format(shout, SHOUT_FORMAT_OGG) != SHOUTERR_SUCCESS) {
		printf("Error setting user: %s\n", shout_get_error(shout));
		shout_error=1;
	}

	gtk_progress_bar_pulse (w);
	while (gtk_events_pending ())
      		gtk_main_iteration ();
        g_usleep (250000);
	gtk_progress_bar_set_text(w,"connecting .... ");

	if (shout_error==1) {
		printf("Error setting connection params: %s\n", shout_get_error(shout));
	    	GtkWidget *error_label1 = lookup_widget (GTK_WIDGET (assistant), "error_label1");
		gtk_label_set_text(error_label1, _(shout_get_error(shout)) );
		gtk_progress_bar_set_text(w,shout_get_error(shout));
    		gtk_label_set_text(label, _("Error setting params"));
    		while (gtk_events_pending ())
    		  gtk_main_iteration ();
    		g_usleep (2500000);

	} else if (shout_open(shout) == SHOUTERR_SUCCESS) {
		gtk_progress_bar_set_fraction (w,1);
		printf("Connected to server...\n");
		gtk_progress_bar_set_text(w,"Connected to server...");
    		gtk_label_set_text(label, _("Server configuration is OK!"));
    		while (gtk_events_pending ())
    		  gtk_main_iteration ();
    		g_usleep (2500000);
	} else {
		gtk_progress_bar_set_fraction (w,1);
		printf("Error connecting: %s\n", shout_get_error(shout));
	    	GtkWidget *error_label1 = lookup_widget (GTK_WIDGET (assistant), "error_label1");
		gtk_label_set_text(error_label1, _(shout_get_error(shout)) );
		gtk_progress_bar_set_text(w,shout_get_error(shout));
    		gtk_label_set_text(label, _("Error connecting"));
    		while (gtk_events_pending ())
    		  gtk_main_iteration ();
    		g_usleep (2500000);
		shout_error=1;
	}

	shout_close(shout);

	shout_shutdown();



    gtk_widget_hide (win);

    if (shout_error == 0) {

	    GtkWidget *video_alignment = lookup_widget (GTK_WIDGET (assistant), "video_sources_alignment");
	    gtk_assistant_set_page_complete (assistant,video_alignment,FALSE);
	
	    dev_count = device_detection(assistant);
			
	    gtk_assistant_set_current_page (assistant,3);
	
	    if (dev_count == 0) {
		
		gtk_assistant_set_page_title(assistant,video_alignment,"No video device detected");
		//TODO fer un boto per a cridar de nou a detetect devices
		gtk_container_remove (video_alignment, gtk_bin_get_child (video_alignment));
		GtkWidget *vbox = gtk_vbox_new(FALSE, 12);
    		gtk_widget_show(vbox);
    		GtkWidget *label= gtk_label_new (_("No video devices detected maybe you'll should connect or close apps"));
    		gtk_widget_show(label);
   	 	gtk_container_add(GTK_CONTAINER(vbox), label);
    		GtkWidget *button_dev= gtk_button_new_with_label (_("Try autodetect devices!"));
    		gtk_widget_show(button_dev);
    		gtk_container_add(GTK_CONTAINER(vbox), button_dev);
		gtk_container_add (GTK_CONTAINER (video_alignment), vbox);

  		g_signal_connect (G_OBJECT (button_dev), "clicked",
                    G_CALLBACK (assistant_button_dev_clicked), (gpointer) assistant);
	
	    } else {

		//alguna cosa si tot ha anat bé?
		gtk_assistant_set_page_title(assistant,video_alignment,_("Select Video Source"));
    	}

    } ///end if (shout_error == 0)
			
   } //end if prepare page 2
}


int device_detection (GtkAssistant *assistant)
{

    GtkWidget *win, *label, *w, *vbox;
    guint sid;
    int dev_count=0;


    /* create the modal window which warns the user to wait */
    win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_size_request (win, 450, 80);
    gtk_window_set_modal(GTK_WINDOW(win), TRUE);
    gtk_window_set_transient_for (GTK_WINDOW (win), 
				    GTK_WINDOW (assistant));
    gtk_window_set_title(GTK_WINDOW(win), _("Discovering video devices"));
    gtk_window_set_icon_from_file (GTK_WINDOW (win), PACKAGE_DATA_DIR "/tss/pixmaps/icon.bmp", NULL);
    gtk_container_set_border_width(GTK_CONTAINER(win), 12);
    g_signal_connect(win, "delete_event", G_CALLBACK(gtk_true), NULL);
    vbox = gtk_vbox_new(FALSE, 12);
    gtk_widget_show(vbox);
    /* create label */
    label = gtk_label_new("Please wait...");
    gtk_widget_show(label);
    gtk_container_add(GTK_CONTAINER(vbox), label);
    /* create progress bar */
    w = gtk_progress_bar_new();
    gtk_widget_show(w);
    gtk_container_add(GTK_CONTAINER(vbox), w);
    /* add vbox to dialog */
    gtk_container_add(GTK_CONTAINER(win), vbox);
    gtk_widget_show (win);
    /* We make sure the dialog is visible. */
    gtk_window_present (GTK_WINDOW (win));

	//borrem possibles thumbnails anteriors
	system("rm /tmp/tss_thumbnail_*.jpg");

	//simulem una mica de moviment a la barra
	for (int j=0; j<9; j++) {
    		gtk_label_set_text(label, _("Dicovering video devices...."));
		gtk_progress_bar_set_text(w,_("Please Wait ...."));
		gtk_progress_bar_pulse (w);
    		while (gtk_events_pending ())
      			gtk_main_iteration ();
    		g_usleep (50000);
	}


	int discover_error = 0;

	const char*dev_name[4] = {"/dev/raw1394","/dev/video0","/dev/video1","/dev/video2"};
	int dev_type[4] = {-1,-1,-1,-1}; // -1=not_tested, 0=dv1394, 1=v4l1 , 2=v4l2
	const char*dev_thumb[4] = {"/tmp/tss_thumbnail_0.jpg","/tmp/tss_thumbnail_1.jpg","/tmp/tss_thumbnail_2.jpg","/tmp/tss_thumbnail_3.jpg"};
	const char dev_str_name[4][32];


	for (int j=0; j<4; j++) {

		//fprintf(stderr,"inici de tests per al device %s\n",dev_name[j]);
    		gtk_label_set_text(label, _("Dicovering video devices...."));
		gtk_progress_bar_set_text(w,dev_name[j]);
		gtk_progress_bar_pulse (w);
    		while (gtk_events_pending ())
      			gtk_main_iteration ();
    		g_usleep (350000);

		
        	struct stat st; 
		int fd;

        	if (-1 == stat (dev_name[j], &st)) {
                	fprintf (stderr, "Cannot identify '%s': %d, %s\n",
                	         dev_name[j], errno, strerror (errno));
        	} else if (!S_ISCHR (st.st_mode)) {
                	fprintf (stderr, "%s is no device\n", dev_name[j]);
			break;
        	} else {
			//el fitxer de dispositiu existeix i es un un chardev 
			//proem d'obrir-lo
        		fd = open (dev_name[j], O_RDWR /* required */ | O_NONBLOCK, 0);

        		if (-1 == fd) {
                		//sino podem obrirlo mirarem si es un problema de permisos
                		fprintf (stderr, "Cannot open '%s': %d, %s\n",
                		         dev_name[j], errno, strerror (errno));
				if (13 == errno) { //13 = permision denied
					char chmod_command[50];
					sprintf(chmod_command,"gksudo chmod a+rw %s",dev_name[j]);
					system(chmod_command);
					fd = open (dev_name[j], O_RDWR /* required */ | O_NONBLOCK, 0);
				}
        		}
        		if (-1 == fd) {
                		//si tot i fer el chmod seguim sense poder obrirlo deu haver-hi un altre error
                		fprintf (stderr, "Cannot open '%s': %d, %s\n",
                		         dev_name[j], errno, strerror (errno));
        		} else {
				//si arrivem aqui vol dir que l'hem acoseguit obrir
				fprintf(stderr,"Device openend %s\n",dev_name[j]);

				if (j==0) { //dispositiu DV
					close(fd);
					//creem el thumbnail
					//amb dvgrab es facil si chuta chuta i si no res
					system("dvgrab -jpeg-over -jpeg-w=160 -jpeg-h=120 -d smtpe=1 /tmp/tss_thumbnail_0.jpg");
					dev_type[j] = 0;
					sprintf(dev_str_name[j],"DV Camera");
				} else { //dispositiu V4L 
				 	//esbrinem primer  si V4L1 o V4L2
        				struct v4l2_capability cap;
					memset(&cap,0,sizeof(cap));
        				if (-1 == xioctl (fd, VIDIOC_QUERYCAP, &cap)) {
                        				fprintf (stderr, "%s is no V4L2 device\n",dev_name[j]);
                        				//tot i que no es V4L2 podria ser una V4L1
							struct video_capability  capability;
							memset(&capability,0,sizeof(capability));
							if (-1 == ioctl(fd,VIDIOCGCAP,&capability)) {
                        					fprintf (stderr, "%s is no V4L1 device\n",dev_name[j]);
							} else {
								dev_type[j] = 1;
								sprintf(dev_str_name[j],"%s",capability.name);
								close(fd);
							//provarem de pillar el thumbnail amb v4l amb v4l1
								char ffmpeg_cmd[200];
								//fprintf(stderr,"tenim un V4L1 que es diu %s\n", capability.name);
								sprintf(ffmpeg_cmd, "ffmpeg -f video4linux -s 320x240 -r 60000/1001 -i %s -vframes 1 -ss 2 -y -s 160x120 -f image2 %s", dev_name[j], dev_thumb[j]);	
								//-r 60000/1001  recorda que sense aixo no funciona v4l1 !!!
								//donaba un error [video4linux @ 0x623fd0]Wrong time base (0)
								system(ffmpeg_cmd);
							}
        				} else {
						// aixo es segur un v4l2 !!
						//fprintf(stderr,"tenim un V4L2 que es diu %s\n", cap.card);
						dev_type[j] = 2;
						sprintf(dev_str_name[j],"%s",cap.card);
						close(fd);
						//pillem el thumbnail amb v4l2
						char ffmpeg_cmd[200];
						sprintf(ffmpeg_cmd, "ffmpeg -f video4linux2 -s 320x240 -i %s -vframes 1 -ss 2 -y -s 160x120 -f image2 %s", dev_name[j], dev_thumb[j]);	
						system(ffmpeg_cmd);
					}
						

				}

			}

		}

	}







	//TODO finalment veiem quins thumbnails hi ha si no n'hi ha cap discover_error=1

	if (discover_error==1) {
		gtk_progress_bar_set_fraction (w,1);
		gtk_progress_bar_set_text(w,"no camera exists");
    		gtk_label_set_text(label, _("No camera exists"));
    		while (gtk_events_pending ())
    		  gtk_main_iteration ();
    		g_usleep (2500000);
		//TODO prova a fer un salt a una altre pagina amb un txt de uebon trata de arrancarlo

	} else {
		gtk_progress_bar_set_fraction (w,1);
		printf("Some video source is detected...\n");
		gtk_progress_bar_set_text(w,"Some video source is detected");
    		gtk_label_set_text(label, _("Some video source is detected"));
    		while (gtk_events_pending ())
    		  gtk_main_iteration ();
    		g_usleep (2500000);


  		GtkWidget *hbox = gtk_hbox_new (FALSE, 5);

		GtkWidget *fake_button = gtk_radio_button_new(NULL);

	for (int j=0; j<4; j++) {

		GError *error = NULL;
		GdkPixbuf *pix = gdk_pixbuf_new_from_file (dev_thumb[j], &error);
		if (pix == NULL) {
    			g_printerr ("Error loading thumbnail file: #%d %s\n", error->code, error->message);
    			g_error_free (error);
   		 	//exit (1);
		} else {
			dev_count++;
			GtkWidget *image = gtk_image_new_from_pixbuf (pix);
			gtk_widget_show(image);
  			GtkWidget *vbox = gtk_vbox_new (FALSE, 5);
			//TODO treure els textes ID de cada cam
			GtkWidget *checkbutton =  gtk_radio_button_new_with_label_from_widget(fake_button,dev_str_name[j]);
			gtk_widget_show(checkbutton);
  			gtk_box_pack_start (GTK_BOX (vbox), checkbutton, TRUE, FALSE, 5);
  			gtk_box_pack_start (GTK_BOX (vbox), image, TRUE, FALSE, 5);
  			gtk_box_pack_start (GTK_BOX (hbox), vbox, TRUE, FALSE, 5);
			gtk_widget_show(vbox);
			char checkbutton_id[21];
			sprintf(checkbutton_id,"video_checkbutton%d",j);
  			GLADE_HOOKUP_OBJECT (assistant, checkbutton, checkbutton_id);
  			g_signal_connect (G_OBJECT (checkbutton), "toggled",
                    		G_CALLBACK (assistant_video_checkbutton_toggled), (gpointer) assistant);
  			gtk_object_set_data (GTK_OBJECT (checkbutton), "ident", j);
		}

	}

		gtk_widget_show(hbox);
  		GtkWidget *video_alignment = lookup_widget (GTK_WIDGET (assistant), "video_sources_alignment");
		gtk_container_remove (video_alignment, gtk_bin_get_child (video_alignment));
		gtk_container_add (GTK_CONTAINER (video_alignment), hbox);
		
	} 

    gtk_widget_hide (win);
    return dev_count;

}

/* This function is where you would apply the changes and destroy the assistant. */
void
assistant_close (GtkAssistant *assistant,
                 gpointer data)
{
  g_print ("apply your changes now!\n");

  GtkWidget *profile_combobox = lookup_widget(GTK_WIDGET(assistant), "profile_combobox");
  const char*urls[4] = {"","http://giss.tv","http://generatech.org","http://stream.hangar.org"};
  const char*name[4] = {"","giss","generatech","Hangar"};
  int index = gtk_combo_box_get_active(GTK_COMBO_BOX(profile_combobox));


  GtkWidget *main_window = gtk_object_get_data (GTK_OBJECT (assistant), MainWindowKey);

  GtkEntry *main_server_entry = lookup_widget (GTK_WIDGET (main_window), "entry39");
  GtkEntry *server_entry = lookup_widget (GTK_WIDGET (assistant), "server_entry");
  gtk_entry_set_text (main_server_entry, gtk_entry_get_text (server_entry));
  GtkEntry *main_port_entry = lookup_widget (GTK_WIDGET (main_window), "entry40");
  GtkEntry *port_entry = lookup_widget (GTK_WIDGET (assistant), "port_entry");
  gtk_entry_set_text (main_port_entry, gtk_entry_get_text (port_entry));
  GtkEntry *main_mount_entry = lookup_widget (GTK_WIDGET (main_window), "entry41");
  GtkEntry *mount_entry = lookup_widget (GTK_WIDGET (assistant), "mount_entry");
  char mountpoint[256];
  if (index == 2) {
	sprintf(mountpoint,"generatech_%s.ogg",gtk_entry_get_text (mount_entry));
  } else  sprintf(mountpoint,"%s",gtk_entry_get_text (mount_entry));
  gtk_entry_set_text (main_mount_entry, mountpoint);
  GtkEntry *main_pass_entry = lookup_widget (GTK_WIDGET (main_window), "entry42");
  GtkEntry *pass_entry = lookup_widget (GTK_WIDGET (assistant), "pass_entry");
  gtk_entry_set_text (main_pass_entry, gtk_entry_get_text (pass_entry));

  /*metadata*/
  GtkEntry *main_entry = lookup_widget(GTK_WIDGET(main_window), "entry53"); //artist
  GtkEntry *entry = lookup_widget(GTK_WIDGET(assistant), "author_entry");
  gtk_entry_set_text (main_entry, gtk_entry_get_text (entry));
  main_entry = lookup_widget(GTK_WIDGET(main_window), "entry52"); //title 
  entry = lookup_widget(GTK_WIDGET(assistant), "title_entry");
  gtk_entry_set_text (main_entry, gtk_entry_get_text (entry));
  main_entry = lookup_widget(GTK_WIDGET(main_window), "entry46"); //description
  gtk_entry_set_text (main_entry, gtk_entry_get_text (entry));
  main_entry = lookup_widget(GTK_WIDGET(main_window), "entry44"); //name         
  gtk_entry_set_text (main_entry, gtk_entry_get_text (entry));
  main_entry = lookup_widget(GTK_WIDGET(main_window), "entry51"); //date
  gtk_entry_set_text (main_entry, ""); //TODO set timedate
  main_entry = lookup_widget(GTK_WIDGET(main_window), "entry50"); //location
  gtk_entry_set_text (main_entry, ""); 
  main_entry = lookup_widget(GTK_WIDGET(main_window), "entry49"); //organization
  gtk_entry_set_text (main_entry, name[index]); 
  main_entry = lookup_widget(GTK_WIDGET(main_window), "entry48"); //copyright    
  gtk_entry_set_text (main_entry, name[index]);
  main_entry = lookup_widget(GTK_WIDGET(main_window), "entry47"); //license      
  gtk_entry_set_text (main_entry, "Creative Commons SA"); 
  main_entry = lookup_widget(GTK_WIDGET(main_window), "entry45"); //genre        
  gtk_entry_set_text (main_entry, "Video Broadcast");
  main_entry = lookup_widget(GTK_WIDGET(main_window), "entry43"); //url          
  gtk_entry_set_text (main_entry, urls[index]); 


  GtkWidget *toggle;
  GtkWidget *combo;
  /**video device*/
  if (assistant_device_selection==0) {
   	toggle = lookup_widget (GTK_WIDGET (main_window), "checkbutton3"); //dv
   	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),TRUE);
  } else if (assistant_device_selection>0) {
   	toggle = lookup_widget (GTK_WIDGET (main_window), "checkbutton2"); //v4l
   	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),TRUE);
   	combo = lookup_widget (GTK_WIDGET (main_window), "combobox14"); //v4l device
   	gtk_combo_box_set_active(GTK_COMBO_BOX(combo),assistant_device_selection-1);
   	combo = lookup_widget (GTK_WIDGET (main_window), "combobox15"); //audio device
   	gtk_combo_box_set_active(GTK_COMBO_BOX(combo),0);
   }

	
   int config[3][8] = {{0,1,2,4,0,1,96,32},{3,1,3,5,1,2,160,96},{4,0,5,7,1,2,384,128}};

   combo = lookup_widget (GTK_WIDGET (assistant), "video_settings");
   int settings = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));


   	combo = lookup_widget (GTK_WIDGET (main_window), "combobox7"); //video size
	gtk_combo_box_set_active(GTK_COMBO_BOX(combo), config[settings][0]);
	combo = lookup_widget (GTK_WIDGET (main_window), "combobox6"); //framerate
	gtk_combo_box_set_active(GTK_COMBO_BOX(combo), config[settings][1]);
	combo = lookup_widget (GTK_WIDGET (main_window), "combobox5"); //video quality
	gtk_combo_box_set_active(GTK_COMBO_BOX(combo), config[settings][2]);
	combo = lookup_widget (GTK_WIDGET (main_window), "combobox4"); // audio quality
	gtk_combo_box_set_active(GTK_COMBO_BOX(combo), config[settings][3]);
	combo = lookup_widget (GTK_WIDGET (main_window), "combobox3"); //audio channels
	gtk_combo_box_set_active(GTK_COMBO_BOX(combo), config[settings][4]);
	combo = lookup_widget (GTK_WIDGET (main_window), "combobox2"); //audio samplerate
	gtk_combo_box_set_active(GTK_COMBO_BOX(combo), config[settings][5]);
	combo = lookup_widget (GTK_WIDGET (main_window), "combobox_vbps");
	gtk_spin_button_set_value(combo, config[settings][6]);
	combo = lookup_widget (GTK_WIDGET (main_window), "combobox_abps");
	gtk_spin_button_set_value(combo, config[settings][7]);




  gtk_widget_hide (assistant);
}

void
assistant_button_dev_clicked (GtkButton *button,
                GtkAssistant *assistant)
{
	    GtkWidget *video_alignment = lookup_widget (GTK_WIDGET (assistant), "video_sources_alignment");
	    gtk_assistant_set_page_complete (assistant,video_alignment,FALSE);

	    int dev_count = device_detection(assistant);
			
	    gtk_assistant_set_current_page (assistant,3);
	
	
	    if (dev_count == 0) {
		
		gtk_assistant_set_page_title(assistant,video_alignment,"No video device detected");
		//TODO fer un boto per a cridar de nou a detetect devices
		gtk_container_remove (video_alignment, gtk_bin_get_child (video_alignment));
		GtkWidget *vbox = gtk_vbox_new(FALSE, 12);
    		gtk_widget_show(vbox);
    		GtkWidget *label= gtk_label_new (_("No video devices detected maybe you'll should connect or close apps"));
    		gtk_widget_show(label);
   	 	gtk_container_add(GTK_CONTAINER(vbox), label);
    		GtkWidget *button_dev= gtk_button_new_with_label (_("Try autodetect devices!"));
    		gtk_widget_show(button_dev);
    		gtk_container_add(GTK_CONTAINER(vbox), button_dev);
		gtk_container_add (GTK_CONTAINER (video_alignment), vbox);

  		g_signal_connect (G_OBJECT (button_dev), "clicked",
                    G_CALLBACK (assistant_button_dev_clicked), (gpointer) assistant);
	
	    } else {
	
		//algo a fer si hi ha hagut deteccio?
		gtk_assistant_set_page_title(assistant,video_alignment,_("Select Video Source"));

    	}


}
